/***********************************************************
*                      K O U L E S                         *
*----------------------------------------------------------*
*  C1995 JAHUSOFT                                          *
*        Jan Hubicka                                       *
*        Dukelskych Bojovniku 1944                         *
*        390 03 Tabor                                      *
*        Czech Republic                                    *
*        Phone: 0041-361-32613                             *
*        eMail: hubicka@limax.paru.cas.cz                  *
*----------------------------------------------------------*
*   Copyright(c)1995,1996 by Jan Hubicka.See README for    *
*                    licence details.                      *
*----------------------------------------------------------*
*  interface.h   interface for SDL                         *
***********************************************************/
/* DKS
#include <vga.h>
#include <vgagl.h>
#include <vgakeyboard.h>
*/

// DKS
#include "SDL/SDL.h"
#include "SDL/SDL_gfxPrimitives.h"
#include "SFont.h"


#ifdef MOUSE
#include <vgamouse.h>
#endif

//DKS
//#include <input.h>
#include "input.h"

#define EYE_RADIUS (DIV==1?5:6)
#define MOUSE_RADIUS 4

//DKS #define SVGALIBSUPPORT


//DKS typedef char   *RawBitmapType;

//DKS typedef char   *BitmapType;


//DKS typedef GraphicsContext *VScreenType;


#ifndef PLATFORM_VARIABLES_HERE
extern int      GAMEWIDTH;
extern int      GAMEHEIGHT;
extern int      MAPWIDTH;
extern int      MAPHEIGHT;
extern int      DIV;

extern int	flipping;
//DKS extern int	page;

//DKS - need to use SFont now
//extern void    *fontblack;
//extern void    *fontwhite;
extern SFont_Font *fontblack;
extern SDL_Surface *fontblack_surface;
extern SFont_Font *fontwhite;
extern SDL_Surface *fontwhite_surface;



/*DKS - modified
extern VScreenType physicalscreen;
extern VScreenType backscreen;
extern VScreenType background;
extern VScreenType starbackground;
*/

extern SDL_Surface *physicalscreen;
extern SDL_Surface *background;
extern SDL_Surface *starbackground;

//DKS - had to add these declarations to fix compiler problems
//Added by DKS - custom palette representations (8-bit game converted to palette-less format)
extern Uint32   colors_RGBA[256];  //Stores full RGBA representation of palette for SDL_gfx usage
extern Uint16   colors_16bit[256]; //Stores 16-bit RGB representation of original
                                   //palette for standard SDL pixel-level access

#endif


#define Truecolor 0
#define FastAccess 1

//DKS #define BitmapToBuffer(bitmap) (bitmap)

//DKS #define VScreenToBuffer(screen) (screen)->vbuf


//DKS #define SetPalette(palette) gl_setpalette (palette)

/* DKS
#define SSetPixel(x,y,color) gl_setpixel(x,y,color)
DKS */


// DKS - Two replacement macros for use w/ 16bpp SDL surfaces
#define SGetPixel(passed_surface, x, y) (((Uint16 *)(passed_surface->pixels))[ ( (y) * passed_surface->w ) + (x) ])
#define SSetPixel(passed_surface, x, y, color) (((Uint16 *)(passed_surface->pixels))[ ( (y) * passed_surface->w ) + (x) ] = (Uint16) (colors_16bit[(color)]))





/* DKS
#if 0
#if DIV==1
#define BSetPixel(bitmap,x,y,color) *(BitmapToBuffer(bitmap)+(x)+(((y)&0xffffff00)>>1)+\
                                (((y)&0xffffff00)<<1))=color
#define SMySetPixel(screen,x,y,color) *(VScreenToBuffer(screen)+(x)+(((y)&0xffffff00)>>1)+\
                                (((y)&0xffffff00)<<1))=color
DKS - was disabled anyway */

/*#define SSetPixel(x,y,color) *((currentcontext.vbuf)+(x)+(y)*MAPWIDTH) )=color */

/* DKS
#else
#define BSetPixel(bitmap,x,y,color) *(BitmapToBuffer(bitmap)+(x)+((y)&0xffffff00)+(((y)\
                                &0xffffff00)>>2))=color
DKS - was disabled anyway */

/*#define SSetPixel(x,y,color) *((currentcontext.vbuf)+(x)+((y)*MAPWIDTH))=color */

/* DKS
#define SMySetPixel(screen,x,y,color) *(VScreenToBuffer(screen)+(x)+((y)&0xffffff00)+(((y)\
                                &0xffffff00)>>2))=color
DKS */


/*mysetpixel is fast setpixel for drawing movers y=realy*256 */

/* DKS - these aren't necessary, we can just use previos SSetPixel and
    screen contexts aren't necessary

#endif
#else
#define BSetPixel(bitmap,x,y,color) *(BitmapToBuffer(bitmap)+(x)+(y)*MAPWIDTH)=color
#define SMySetPixel(screen,x,y,color) *(VScreenToBuffer(screen)+(x)+((y)>>8)*MAPWIDTH)=color
#endif
#define SetScreen(screen) gl_setcontext (screen)
DKS */

//DKS - modified & replaced
//extern inline void
//DrawBlackMaskedText (int x, int y, char *text)
//{
//  gl_setwritemode (WRITEMODE_MASKED);
//  gl_setfont (8, 8, fontblack);
//  gl_write (x, y, text);
//}
//extern inline void
//DrawWhiteMaskedText (int x, int y, char *text)
//{
//  gl_setwritemode (WRITEMODE_MASKED);
//  gl_setfont (8, 8, fontwhite);
//  gl_write (x, y, text);
//}
//extern inline void
//DrawText (int x, int y, char *text)
//{
//  gl_setwritemode (WRITEMODE_OVERWRITE);
//  gl_setfont (8, 8, fontwhite);
//  gl_write (x, y, text);
//}

//DKS added as replacements:
#define DrawBlackMaskedText(passed_surface, x, y, text) \
  SFont_Write((passed_surface), fontblack, (x), (y), (text))

#define DrawWhiteMaskedText(passed_surface, x, y, text) \
  SFont_Write((passed_surface), fontwhite, (x), (y), (text))

extern inline void
DrawText (SDL_Surface *passed_surface, int x, int y, char *text)
{
  SDL_Rect tmp_rect;

  //Get offsets
  tmp_rect.x = x;
  tmp_rect.y = y;
//  tmp_rect.w = SFont_TextWidth(fontwhite, text);
//  tmp_rect.h = SFont_TextHeight(fontwhite);
  tmp_rect.w = strlen(text) * 8;
  tmp_rect.h = 8;

  SDL_FillRect(passed_surface, &tmp_rect, colors_16bit[0]);

  SFont_Write(passed_surface, fontwhite, x, y, text);

}

//DKS - replaced w/ macro
//extern inline void
//DrawRectangle (int x1, int y1, int x2, int y2, int color)
//{
//  gl_line ((int) x1, (int) y1, (int) x1, (int) y2, color);
//  gl_line ((int) x1, (int) y2, (int) x2, (int) y2, color);
//  gl_line ((int) x2, (int) y2, (int) x2, (int) y1, color);
//  gl_line ((int) x2, (int) y1, (int) x1, (int) y1, color);
//}
#define DrawRectangle(passed_surface, x1, y1, x2, y2, color) \
  rectangleColor((passed_surface), (x1), (y1), (x2), (y2), colors_RGBA[(color)])

//DKS
//extern inline char *
//CompileBitmap (int x, int y, char *bitmap)
//{
//  int             size1;
//  char           *cbitmap;
//  size1 = gl_compiledboxmasksize (x, y, bitmap);
//  if ((cbitmap = malloc (size1)) == NULL)
//    perror ("create_bitmap"), exit (1);
//  gl_compileboxmask (x, y, bitmap, cbitmap);
//  return (cbitmap);
//}

//DKS #define FillRectangle(x,y,x1,y1,color) gl_fillbox((x),(y),(x1),(y1),(color))
#define FillRectangle(passed_surface,x,y,x1,y1,color) boxColor(passed_surface, (x), (y), (x1), (y1), colors_RGBA[(color)])

//DKS #define Line(x1,y1,x2,y2,color) gl_line((x1),(y1),(x2),(y2),(color))
#define Line(passed_surface,x1,y1,x2,y2,color) lineColor(passed_surface, (x1), (y1), (x2), (y2), colors_RGBA[(color)])

//DKS #define HLine(x1,y1,x2,color) gl_hline((x1),(y1),(x2),(color))
#define HLine(passed_surface,x1,y1,x2,color) hlineColor(passed_surface, (x1), (x2), (y1), colors_RGBA[(color)])

//DKS #define PutBitmap(x,y,xsize,ysize,bitmap) gl_putboxmaskcompiled((x),(y),(xsize),(ysize),(bitmap))


//DKS added replacement function:
extern inline void PutBitmap( int x, int y, SDL_Surface *source, SDL_Surface *destination)
{

    //Holds offsets
    SDL_Rect offset;

    //Get offsets
    offset.x = x;
    offset.y = y;

    //Blit
    SDL_BlitSurface( source, NULL, destination, &offset );

}

//DKS #define WaitRetrace() vga_waitretrace()
//DKS #define EnableClipping() gl_enableclipping()
//DKS #define DisableClipping() gl_disableclipping()

extern inline void EnableClipping() {
  SDL_Rect cliprect;

  cliprect.x = 0;
  cliprect.y = 0;
  cliprect.w = MAPWIDTH;
  cliprect.h = MAPHEIGHT + 20;

  SDL_SetClipRect(physicalscreen, &cliprect);

}

extern inline void DisableClipping() {
  SDL_SetClipRect(physicalscreen, NULL);
}

//DKS #define ClearScreen() gl_clearscreen (0)
#define ClearScreen(passed_surface) SDL_FillRect( (passed_surface), NULL, colors_16bit[0] )

extern void flippage(void);

/* DKS
extern inline void
CopyVSToVS (VScreenType source, VScreenType destination)
{
  SetScreen (source);
  if(!flipping||(destination!=backscreen&&destination!=physicalscreen))
  gl_copyscreen (destination); else {
    gl_copyboxtocontext(0,0,MAPWIDTH,MAPHEIGHT+20,destination,0,0);
  }
}
*/
//DKS Added modified version:
extern inline void CopyVSToVS( SDL_Surface* source, SDL_Surface* destination)
{
    //Holds offsets
    SDL_Rect offset;

    //Get offsets for copying whole screen surface to another surface
    offset.x = 0;
    offset.y = 0;

    //Blit
    SDL_BlitSurface( source, NULL, destination, &offset );
}



//DKS replaced and modified
//extern inline void
//CopyToScreen (VScreenType source)
//{
//  SetScreen (source);
//  if(!flipping) gl_copyscreen (physicalscreen); else
//   flippage();
//}


//DKS - modified (this function i suppose is for copying back screens to main screen, might not
// need it
extern inline void CopyToScreen( SDL_Surface* source)
{
    //Holds offsets
    SDL_Rect offset;

    //Get offsets for copying whole screen surface to another surface
    offset.x = 0;
    offset.y = 0;

    //Blit
    SDL_BlitSurface( source, NULL, physicalscreen, &offset );
}

#define CharX 8
#define CharY 8
#define FAST_WIDELINE
